diff --git a/src/backend/jit/llvm/llvmjit_deform.c b/src/backend/jit/llvm/llvmjit_deform.c
index 661f15272b..67e958a58a 100644
--- a/src/backend/jit/llvm/llvmjit_deform.c
+++ b/src/backend/jit/llvm/llvmjit_deform.c
@@ -87,7 +87,7 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 	/* if true, known_alignment describes definite offset of column */
 	bool		attguaranteedalign = true;
 
-	int			attnum;
+	int			attphysnum;
 
 	/* virtual tuples never need deforming, so don't generate code */
 	if (ops == &TTSOpsVirtual)
@@ -106,9 +106,9 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 	 * Check which columns have to exist, so we don't have to check the row's
 	 * natts unnecessarily.
 	 */
-	for (attnum = 0; attnum < desc->natts; attnum++)
+	for (attphysnum = 0; attphysnum < desc->natts; attphysnum++)
 	{
-		Form_pg_attribute att = TupleDescAttr(desc, attnum);
+		Form_pg_attribute att = TupleDescAttr(desc, attphysnum);
 
 		/*
 		 * If the column is declared NOT NULL then it must be present in every
@@ -124,7 +124,7 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 		if (att->attnotnull &&
 			!att->atthasmissing &&
 			!att->attisdropped)
-			guaranteed_column_number = attnum;
+			guaranteed_column_number = attphysnum;
 	}
 
 	/* Create the signature and function */
@@ -280,20 +280,20 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 	}
 
 	/* build the basic block for each attribute, need them as jump target */
-	for (attnum = 0; attnum < natts; attnum++)
+	for (attphysnum = 0; attphysnum < natts; attphysnum++)
 	{
-		attcheckattnoblocks[attnum] =
-			l_bb_append_v(v_deform_fn, "block.attr.%d.attcheckattno", attnum);
-		attstartblocks[attnum] =
-			l_bb_append_v(v_deform_fn, "block.attr.%d.start", attnum);
-		attisnullblocks[attnum] =
-			l_bb_append_v(v_deform_fn, "block.attr.%d.attisnull", attnum);
-		attcheckalignblocks[attnum] =
-			l_bb_append_v(v_deform_fn, "block.attr.%d.attcheckalign", attnum);
-		attalignblocks[attnum] =
-			l_bb_append_v(v_deform_fn, "block.attr.%d.align", attnum);
-		attstoreblocks[attnum] =
-			l_bb_append_v(v_deform_fn, "block.attr.%d.store", attnum);
+		attcheckattnoblocks[attphysnum] =
+			l_bb_append_v(v_deform_fn, "block.attr.%d.attcheckattno", attphysnum);
+		attstartblocks[attphysnum] =
+			l_bb_append_v(v_deform_fn, "block.attr.%d.start", attphysnum);
+		attisnullblocks[attphysnum] =
+			l_bb_append_v(v_deform_fn, "block.attr.%d.attisnull", attphysnum);
+		attcheckalignblocks[attphysnum] =
+			l_bb_append_v(v_deform_fn, "block.attr.%d.attcheckalign", attphysnum);
+		attalignblocks[attphysnum] =
+			l_bb_append_v(v_deform_fn, "block.attr.%d.align", attphysnum);
+		attstoreblocks[attphysnum] =
+			l_bb_append_v(v_deform_fn, "block.attr.%d.store", attphysnum);
 	}
 
 	/*
@@ -350,11 +350,11 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 		LLVMValueRef v_switch = LLVMBuildSwitch(b, v_nvalid,
 												b_dead, natts);
 
-		for (attnum = 0; attnum < natts; attnum++)
+		for (attphysnum = 0; attphysnum < natts; attphysnum++)
 		{
-			LLVMValueRef v_attno = l_int16_const(attnum);
+			LLVMValueRef v_attno = l_int16_const(attphysnum);
 
-			LLVMAddCase(v_switch, v_attno, attcheckattnoblocks[attnum]);
+			LLVMAddCase(v_switch, v_attno, attcheckattnoblocks[attphysnum]);
 		}
 	}
 	else
@@ -370,23 +370,23 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 	 * Iterate over each attribute that needs to be deformed, build code to
 	 * deform it.
 	 */
-	for (attnum = 0; attnum < natts; attnum++)
+	for (attphysnum = 0; attphysnum < natts; attphysnum++)
 	{
-		Form_pg_attribute att = TupleDescAttr(desc, attnum);
+		Form_pg_attribute att = TupleDescAttr(desc, attphysnum);
 		LLVMValueRef v_incby;
 		int			alignto;
-		LLVMValueRef l_attno = l_int16_const(attnum);
+		LLVMValueRef l_attno = l_int16_const(attphysnum);
 		LLVMValueRef v_attdatap;
 		LLVMValueRef v_resultp;
 
 		/* build block checking whether we did all the necessary attributes */
-		LLVMPositionBuilderAtEnd(b, attcheckattnoblocks[attnum]);
+		LLVMPositionBuilderAtEnd(b, attcheckattnoblocks[attphysnum]);
 
 		/*
 		 * If this is the first attribute, slot->tts_nvalid was 0. Therefore
 		 * also reset offset to 0, it may be from a previous execution.
 		 */
-		if (attnum == 0)
+		if (attphysnum == 0)
 		{
 			LLVMBuildStore(b, l_sizet_const(0), v_offp);
 		}
@@ -396,9 +396,9 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 		 * that many columns stored). We can avoid the branch if we know
 		 * there's a subsequent NOT NULL column.
 		 */
-		if (attnum <= guaranteed_column_number)
+		if (attphysnum <= guaranteed_column_number)
 		{
-			LLVMBuildBr(b, attstartblocks[attnum]);
+			LLVMBuildBr(b, attstartblocks[attphysnum]);
 		}
 		else
 		{
@@ -408,9 +408,9 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 									 l_attno,
 									 v_maxatt,
 									 "heap_natts");
-			LLVMBuildCondBr(b, v_islast, b_out, attstartblocks[attnum]);
+			LLVMBuildCondBr(b, v_islast, b_out, attstartblocks[attphysnum]);
 		}
-		LLVMPositionBuilderAtEnd(b, attstartblocks[attnum]);
+		LLVMPositionBuilderAtEnd(b, attstartblocks[attphysnum]);
 
 		/*
 		 * Check for nulls if necessary. No need to take missing attributes
@@ -428,16 +428,16 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 			LLVMValueRef v_nullbyte;
 			LLVMValueRef v_nullbit;
 
-			b_ifnotnull = attcheckalignblocks[attnum];
-			b_ifnull = attisnullblocks[attnum];
+			b_ifnotnull = attcheckalignblocks[attphysnum];
+			b_ifnull = attisnullblocks[attphysnum];
 
-			if (attnum + 1 == natts)
+			if (attphysnum + 1 == natts)
 				b_next = b_out;
 			else
-				b_next = attcheckattnoblocks[attnum + 1];
+				b_next = attcheckattnoblocks[attphysnum + 1];
 
-			v_nullbyteno = l_int32_const(attnum >> 3);
-			v_nullbytemask = l_int8_const(1 << ((attnum) & 0x07));
+			v_nullbyteno = l_int32_const(attphysnum >> 3);
+			v_nullbytemask = l_int8_const(1 << ((attphysnum) & 0x07));
 			v_nullbyte = l_load_gep1(b, v_bits, v_nullbyteno, "attnullbyte");
 
 			v_nullbit = LLVMBuildICmp(b,
@@ -467,11 +467,11 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 		else
 		{
 			/* nothing to do */
-			LLVMBuildBr(b, attcheckalignblocks[attnum]);
-			LLVMPositionBuilderAtEnd(b, attisnullblocks[attnum]);
-			LLVMBuildBr(b, attcheckalignblocks[attnum]);
+			LLVMBuildBr(b, attcheckalignblocks[attphysnum]);
+			LLVMPositionBuilderAtEnd(b, attisnullblocks[attphysnum]);
+			LLVMBuildBr(b, attcheckalignblocks[attphysnum]);
 		}
-		LLVMPositionBuilderAtEnd(b, attcheckalignblocks[attnum]);
+		LLVMPositionBuilderAtEnd(b, attcheckalignblocks[attphysnum]);
 
 		/* determine required alignment */
 		if (att->attalign == TYPALIGN_INT)
@@ -527,15 +527,15 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 								  v_possible_padbyte, l_int8_const(0),
 								  "ispadbyte");
 				LLVMBuildCondBr(b, v_ispad,
-								attalignblocks[attnum],
-								attstoreblocks[attnum]);
+								attalignblocks[attphysnum],
+								attstoreblocks[attphysnum]);
 			}
 			else
 			{
-				LLVMBuildBr(b, attalignblocks[attnum]);
+				LLVMBuildBr(b, attalignblocks[attphysnum]);
 			}
 
-			LLVMPositionBuilderAtEnd(b, attalignblocks[attnum]);
+			LLVMPositionBuilderAtEnd(b, attalignblocks[attphysnum]);
 
 			/* translation of alignment code (cf TYPEALIGN()) */
 			{
@@ -567,17 +567,17 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 				known_alignment = TYPEALIGN(alignto, known_alignment);
 			}
 
-			LLVMBuildBr(b, attstoreblocks[attnum]);
-			LLVMPositionBuilderAtEnd(b, attstoreblocks[attnum]);
+			LLVMBuildBr(b, attstoreblocks[attphysnum]);
+			LLVMPositionBuilderAtEnd(b, attstoreblocks[attphysnum]);
 		}
 		else
 		{
-			LLVMPositionBuilderAtEnd(b, attcheckalignblocks[attnum]);
-			LLVMBuildBr(b, attalignblocks[attnum]);
-			LLVMPositionBuilderAtEnd(b, attalignblocks[attnum]);
-			LLVMBuildBr(b, attstoreblocks[attnum]);
+			LLVMPositionBuilderAtEnd(b, attcheckalignblocks[attphysnum]);
+			LLVMBuildBr(b, attalignblocks[attphysnum]);
+			LLVMPositionBuilderAtEnd(b, attalignblocks[attphysnum]);
+			LLVMBuildBr(b, attstoreblocks[attphysnum]);
 		}
-		LLVMPositionBuilderAtEnd(b, attstoreblocks[attnum]);
+		LLVMPositionBuilderAtEnd(b, attstoreblocks[attphysnum]);
 
 		/*
 		 * Store the current offset if known to be constant. That allows LLVM
@@ -720,14 +720,14 @@ slot_compile_deform(LLVMJitContext *context, TupleDesc desc,
 		 * jump to next block, unless last possible column, or all desired
 		 * (available) attributes have been fetched.
 		 */
-		if (attnum + 1 == natts)
+		if (attphysnum + 1 == natts)
 		{
 			/* jump out */
 			LLVMBuildBr(b, b_out);
 		}
 		else
 		{
-			LLVMBuildBr(b, attcheckattnoblocks[attnum + 1]);
+			LLVMBuildBr(b, attcheckattnoblocks[attphysnum + 1]);
 		}
 	}
 
diff --git a/src/backend/jit/llvm/llvmjit_expr.c b/src/backend/jit/llvm/llvmjit_expr.c
index b6b6512ef1..f12bff8103 100644
--- a/src/backend/jit/llvm/llvmjit_expr.c
+++ b/src/backend/jit/llvm/llvmjit_expr.c
@@ -372,7 +372,7 @@ llvm_compile_expr(ExprState *state)
 						v_nulls = v_scannulls;
 					}
 
-					v_attnum = l_int32_const(op->d.var.attnum);
+					v_attnum = l_int32_const(op->d.var.attphysnum);
 					value = l_load_gep1(b, v_values, v_attnum, "");
 					isnull = l_load_gep1(b, v_nulls, v_attnum, "");
 					LLVMBuildStore(b, value, v_resvaluep);
@@ -438,7 +438,7 @@ llvm_compile_expr(ExprState *state)
 					}
 
 					/* load data */
-					v_attnum = l_int32_const(op->d.assign_var.attnum);
+					v_attnum = l_int32_const(op->d.assign_var.attphysnum);
 					v_value = l_load_gep1(b, v_values, v_attnum, "");
 					v_isnull = l_load_gep1(b, v_nulls, v_attnum, "");
 
diff --git a/src/backend/optimizer/util/appendinfo.c b/src/backend/optimizer/util/appendinfo.c
index 9d4bb47027..ca83ecb997 100644
--- a/src/backend/optimizer/util/appendinfo.c
+++ b/src/backend/optimizer/util/appendinfo.c
@@ -150,7 +150,7 @@ make_inh_translation_list(Relation oldrelation, Relation newrelation,
 			if (!HeapTupleIsValid(newtup))
 				elog(ERROR, "could not find inherited attribute \"%s\" of relation \"%s\"",
 					 attname, RelationGetRelationName(newrelation));
-			new_attno = ((Form_pg_attribute) GETSTRUCT(newtup))->attnum - 1;
+			new_attno = ((Form_pg_attribute) GETSTRUCT(newtup))->attphysnum - 1;
 			Assert(new_attno >= 0 && new_attno < newnatts);
 			ReleaseSysCache(newtup);
 
diff --git a/src/backend/parser/analyze.c b/src/backend/parser/analyze.c
index 1bcb875507..5ced631957 100644
--- a/src/backend/parser/analyze.c
+++ b/src/backend/parser/analyze.c
@@ -1246,9 +1246,9 @@ count_rowexpr_columns(ParseState *pstate, Node *expr)
 	if (IsA(expr, Var))
 	{
 		Var		   *var = (Var *) expr;
-		AttrNumber	attnum = var->varattno;
+		AttrNumber	attphysnum = var->varattno;
 
-		if (attnum > 0 && var->vartype == RECORDOID)
+		if (attphysnum > 0 && var->vartype == RECORDOID)
 		{
 			RangeTblEntry *rte;
 
@@ -1257,7 +1257,7 @@ count_rowexpr_columns(ParseState *pstate, Node *expr)
 			{
 				/* Subselect-in-FROM: examine sub-select's output expr */
 				TargetEntry *ste = get_tle_by_resno(rte->subquery->targetList,
-													attnum);
+													attphysnum);
 
 				if (ste == NULL || ste->resjunk)
 					return -1;
diff --git a/src/backend/parser/parse_clause.c b/src/backend/parser/parse_clause.c
index c655d188c7..d1b0080268 100644
--- a/src/backend/parser/parse_clause.c
+++ b/src/backend/parser/parse_clause.c
@@ -257,11 +257,11 @@ extractRemainingColumns(ParseNamespaceColumn *src_nscolumns,
 {
 	int			colcount = 0;
 	Bitmapset  *prevcols;
-	int			attnum;
+	int			attphysnum;
 	ListCell   *lc;
 
 	/*
-	 * While we could just test "list_member_int(*src_colnos, attnum)" to
+	 * While we could just test "list_member_int(*src_colnos, attphysnum)" to
 	 * detect already-merged columns in the loop below, that would be O(N^2)
 	 * for a wide input table.  Instead build a bitmapset of just the merged
 	 * USING columns, which we won't add to within the main loop.
@@ -272,22 +272,22 @@ extractRemainingColumns(ParseNamespaceColumn *src_nscolumns,
 		prevcols = bms_add_member(prevcols, lfirst_int(lc));
 	}
 
-	attnum = 0;
+	attphysnum = 0;
 	foreach(lc, src_colnames)
 	{
 		char	   *colname = strVal(lfirst(lc));
 
-		attnum++;
+		attphysnum++;
 		/* Non-dropped and not already merged? */
-		if (colname[0] != '\0' && !bms_is_member(attnum, prevcols))
+		if (colname[0] != '\0' && !bms_is_member(attphysnum, prevcols))
 		{
 			/* Yes, so emit it as next output column */
-			*src_colnos = lappend_int(*src_colnos, attnum);
+			*src_colnos = lappend_int(*src_colnos, attphysnum);
 			*res_colnames = lappend(*res_colnames, lfirst(lc));
 			*res_colvars = lappend(*res_colvars,
-								   buildVarFromNSColumn(src_nscolumns + attnum - 1));
+								   buildVarFromNSColumn(src_nscolumns + attphysnum - 1));
 			/* Copy the input relation's nscolumn data for this column */
-			res_nscolumns[colcount] = src_nscolumns[attnum - 1];
+			res_nscolumns[colcount] = src_nscolumns[attphysnum - 1];
 			colcount++;
 		}
 	}
diff --git a/src/backend/parser/parse_relation.c b/src/backend/parser/parse_relation.c
index 926dcbf30e..27c3abb7ec 100644
--- a/src/backend/parser/parse_relation.c
+++ b/src/backend/parser/parse_relation.c
@@ -566,7 +566,7 @@ GetCTEForRTE(ParseState *pstate, RangeTblEntry *rte, int rtelevelsup)
 static void
 updateFuzzyAttrMatchState(int fuzzy_rte_penalty,
 						  FuzzyAttrMatchState *fuzzystate, RangeTblEntry *rte,
-						  const char *actual, const char *match, int attnum)
+						  const char *actual, const char *match, int attphysnum)
 {
 	int			columndistance;
 	int			matchlen;
@@ -613,7 +613,7 @@ updateFuzzyAttrMatchState(int fuzzy_rte_penalty,
 		/* Store new lowest observed distance for RTE */
 		fuzzystate->distance = columndistance;
 		fuzzystate->rfirst = rte;
-		fuzzystate->first = attnum;
+		fuzzystate->first = attphysnum;
 		fuzzystate->rsecond = NULL;
 		fuzzystate->second = InvalidAttrNumber;
 	}
@@ -640,7 +640,7 @@ updateFuzzyAttrMatchState(int fuzzy_rte_penalty,
 		{
 			/* Record as provisional second match for RTE */
 			fuzzystate->rsecond = rte;
-			fuzzystate->second = attnum;
+			fuzzystate->second = attphysnum;
 		}
 		else if (fuzzystate->distance <= MAX_FUZZY_DISTANCE)
 		{
@@ -650,7 +650,7 @@ updateFuzzyAttrMatchState(int fuzzy_rte_penalty,
 			 * than being associated with a real match)
 			 */
 			fuzzystate->rfirst = rte;
-			fuzzystate->first = attnum;
+			fuzzystate->first = attphysnum;
 		}
 	}
 }
@@ -669,23 +669,23 @@ scanNSItemForColumn(ParseState *pstate, ParseNamespaceItem *nsitem,
 					int sublevels_up, const char *colname, int location)
 {
 	RangeTblEntry *rte = nsitem->p_rte;
-	int			attnum;
+	int			attphysnum;
 	Var		   *var;
 
 	/*
 	 * Scan the nsitem's column names (or aliases) for a match.  Complain if
 	 * multiple matches.
 	 */
-	attnum = scanRTEForColumn(pstate, rte, nsitem->p_names,
+	attphysnum = scanRTEForColumn(pstate, rte, nsitem->p_names,
 							  colname, location,
 							  0, NULL);
 
-	if (attnum == InvalidAttrNumber)
+	if (attphysnum == InvalidAttrNumber)
 		return NULL;			/* Return NULL if no match */
 
 	/* In constraint check, no system column is allowed except tableOid */
 	if (pstate->p_expr_kind == EXPR_KIND_CHECK_CONSTRAINT &&
-		attnum < InvalidAttrNumber && attnum != TableOidAttributeNumber)
+		attphysnum < InvalidAttrNumber && attphysnum != TableOidAttributeNumber)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 				 errmsg("system column \"%s\" reference in check constraint is invalid",
@@ -694,7 +694,7 @@ scanNSItemForColumn(ParseState *pstate, ParseNamespaceItem *nsitem,
 
 	/* In generated column, no system column is allowed except tableOid */
 	if (pstate->p_expr_kind == EXPR_KIND_GENERATED_COLUMN &&
-		attnum < InvalidAttrNumber && attnum != TableOidAttributeNumber)
+		attphysnum < InvalidAttrNumber && attphysnum != TableOidAttributeNumber)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 				 errmsg("cannot use system column \"%s\" in column generation expression",
@@ -705,7 +705,7 @@ scanNSItemForColumn(ParseState *pstate, ParseNamespaceItem *nsitem,
 	 * In a MERGE WHEN condition, no system column is allowed except tableOid
 	 */
 	if (pstate->p_expr_kind == EXPR_KIND_MERGE_WHEN &&
-		attnum < InvalidAttrNumber && attnum != TableOidAttributeNumber)
+		attphysnum < InvalidAttrNumber && attphysnum != TableOidAttributeNumber)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 				 errmsg("cannot use system column \"%s\" in MERGE WHEN condition",
@@ -713,10 +713,10 @@ scanNSItemForColumn(ParseState *pstate, ParseNamespaceItem *nsitem,
 				 parser_errposition(pstate, location)));
 
 	/* Found a valid match, so build a Var */
-	if (attnum > InvalidAttrNumber)
+	if (attphysnum > InvalidAttrNumber)
 	{
 		/* Get attribute data from the ParseNamespaceColumn array */
-		ParseNamespaceColumn *nscol = &nsitem->p_nscolumns[attnum - 1];
+		ParseNamespaceColumn *nscol = &nsitem->p_nscolumns[attphysnum - 1];
 
 		/* Complain if dropped column.  See notes in scanRTEForColumn. */
 		if (nscol->p_varno == 0)
@@ -741,9 +741,9 @@ scanNSItemForColumn(ParseState *pstate, ParseNamespaceItem *nsitem,
 		/* System column, so use predetermined type data */
 		const FormData_pg_attribute *sysatt;
 
-		sysatt = SystemAttributeDefinition(attnum);
+		sysatt = SystemAttributeDefinition(attphysnum);
 		var = makeVar(nsitem->p_rtindex,
-					  attnum,
+					  attphysnum,
 					  sysatt->atttypid,
 					  sysatt->atttypmod,
 					  sysatt->attcollation,
@@ -760,7 +760,7 @@ scanNSItemForColumn(ParseState *pstate, ParseNamespaceItem *nsitem,
 /*
  * scanRTEForColumn
  *	  Search the column names of a single RTE for the given name.
- *	  If found, return the attnum (possibly negative, for a system column);
+ *	  If found, return the attphysnum (possibly negative, for a system column);
  *	  else return InvalidAttrNumber.
  *	  If the name proves ambiguous within this RTE, raise error.
  *
@@ -789,7 +789,7 @@ scanRTEForColumn(ParseState *pstate, RangeTblEntry *rte,
 				 FuzzyAttrMatchState *fuzzystate)
 {
 	int			result = InvalidAttrNumber;
-	int			attnum = 0;
+	int			attphysnum = 0;
 	ListCell   *c;
 
 	/*
@@ -809,7 +809,7 @@ scanRTEForColumn(ParseState *pstate, RangeTblEntry *rte,
 	{
 		const char *attcolname = strVal(lfirst(c));
 
-		attnum++;
+		attphysnum++;
 		if (strcmp(attcolname, colname) == 0)
 		{
 			if (result)
@@ -818,13 +818,13 @@ scanRTEForColumn(ParseState *pstate, RangeTblEntry *rte,
 						 errmsg("column reference \"%s\" is ambiguous",
 								colname),
 						 parser_errposition(pstate, location)));
-			result = attnum;
+			result = attphysnum;
 		}
 
 		/* Update fuzzy match state, if provided. */
 		if (fuzzystate != NULL)
 			updateFuzzyAttrMatchState(fuzzy_rte_penalty, fuzzystate,
-									  rte, attcolname, colname, attnum);
+									  rte, attcolname, colname, attphysnum);
 	}
 
 	/*
@@ -843,14 +843,14 @@ scanRTEForColumn(ParseState *pstate, RangeTblEntry *rte,
 		rte->relkind != RELKIND_COMPOSITE_TYPE)
 	{
 		/* quick check to see if name could be a system column */
-		attnum = specialAttNum(colname);
-		if (attnum != InvalidAttrNumber)
+		attphysnum = specialAttNum(colname);
+		if (attphysnum != InvalidAttrNumber)
 		{
 			/* now check to see if column actually is defined */
-			if (SearchSysCacheExists2(ATTNUM,
+			if (SearchSysCacheExists2(ATTPHYSNUM,
 									  ObjectIdGetDatum(rte->relid),
-									  Int16GetDatum(attnum)))
-				result = attnum;
+									  Int16GetDatum(attphysnum)))
+				result = attphysnum;
 		}
 	}
 
@@ -1023,7 +1023,7 @@ markRTEForSelectPriv(ParseState *pstate, int rtindex, AttrNumber col)
 	{
 		/* Make sure the rel as a whole is marked for SELECT access */
 		rte->requiredPerms |= ACL_SELECT;
-		/* Must offset the attnum to fit in a bitmapset */
+		/* Must offset the attphysnum to fit in a bitmapset */
 		rte->selectedCols = bms_add_member(rte->selectedCols,
 										   col - FirstLowInvalidHeapAttributeNumber);
 	}
@@ -2746,7 +2746,7 @@ expandRTE(RangeTblEntry *rte, int rtindex, int sublevels_up,
 							ListCell   *l1;
 							ListCell   *l2;
 							ListCell   *l3;
-							int			attnum = atts_done;
+							int			attphysnum = atts_done;
 
 							forthree(l1, rtfunc->funccoltypes,
 									 l2, rtfunc->funccoltypmods,
@@ -2757,9 +2757,9 @@ expandRTE(RangeTblEntry *rte, int rtindex, int sublevels_up,
 								Oid			attrcollation = lfirst_oid(l3);
 								Var		   *varnode;
 
-								attnum++;
+								attphysnum++;
 								varnode = makeVar(rtindex,
-												  attnum,
+												  attphysnum,
 												  attrtype,
 												  attrtypmod,
 												  attrcollation,
@@ -3181,21 +3181,21 @@ expandNSItemAttrs(ParseState *pstate, ParseNamespaceItem *nsitem,
  * In particular, it will work on an RTE for a subselect or join, whereas
  * get_attname() only works on real relations.
  *
- * "*" is returned if the given attnum is InvalidAttrNumber --- this case
+ * "*" is returned if the given attphysnum is InvalidAttrNumber --- this case
  * occurs when a Var represents a whole tuple of a relation.
  */
 char *
-get_rte_attribute_name(RangeTblEntry *rte, AttrNumber attnum)
+get_rte_attribute_name(RangeTblEntry *rte, AttrNumber attphysnum)
 {
-	if (attnum == InvalidAttrNumber)
+	if (attphysnum == InvalidAttrNumber)
 		return "*";
 
 	/*
 	 * If there is a user-written column alias, use it.
 	 */
 	if (rte->alias &&
-		attnum > 0 && attnum <= list_length(rte->alias->colnames))
-		return strVal(list_nth(rte->alias->colnames, attnum - 1));
+		attphysnum > 0 && attphysnum <= list_length(rte->alias->colnames))
+		return strVal(list_nth(rte->alias->colnames, attphysnum - 1));
 
 	/*
 	 * If the RTE is a relation, go to the system catalogs not the
@@ -3204,17 +3204,17 @@ get_rte_attribute_name(RangeTblEntry *rte, AttrNumber attnum)
 	 * built (which can easily happen for rules).
 	 */
 	if (rte->rtekind == RTE_RELATION)
-		return get_attname(rte->relid, attnum, false);
+		return get_attname(rte->relid, attphysnum, false);
 
 	/*
 	 * Otherwise use the column name from eref.  There should always be one.
 	 */
-	if (attnum > 0 && attnum <= list_length(rte->eref->colnames))
-		return strVal(list_nth(rte->eref->colnames, attnum - 1));
+	if (attphysnum > 0 && attphysnum <= list_length(rte->eref->colnames))
+		return strVal(list_nth(rte->eref->colnames, attphysnum - 1));
 
-	/* else caller gave us a bogus attnum */
-	elog(ERROR, "invalid attnum %d for rangetable entry %s",
-		 attnum, rte->eref->aliasname);
+	/* else caller gave us a bogus attphysnum */
+	elog(ERROR, "invalid attphysnum %d for rangetable entry %s",
+		 attphysnum, rte->eref->aliasname);
 	return NULL;				/* keep compiler quiet */
 }
 
@@ -3223,7 +3223,7 @@ get_rte_attribute_name(RangeTblEntry *rte, AttrNumber attnum)
  *		Check whether attempted attribute ref is to a dropped column
  */
 bool
-get_rte_attribute_is_dropped(RangeTblEntry *rte, AttrNumber attnum)
+get_rte_attribute_is_dropped(RangeTblEntry *rte, AttrNumber attphysnum)
 {
 	bool		result;
 
@@ -3237,12 +3237,12 @@ get_rte_attribute_is_dropped(RangeTblEntry *rte, AttrNumber attnum)
 				HeapTuple	tp;
 				Form_pg_attribute att_tup;
 
-				tp = SearchSysCache2(ATTNUM,
+				tp = SearchSysCache2(ATTPHYSNUM,
 									 ObjectIdGetDatum(rte->relid),
-									 Int16GetDatum(attnum));
+									 Int16GetDatum(attphysnum));
 				if (!HeapTupleIsValid(tp))	/* shouldn't happen */
 					elog(ERROR, "cache lookup failed for attribute %d of relation %u",
-						 attnum, rte->relid);
+						 attphysnum, rte->relid);
 				att_tup = (Form_pg_attribute) GETSTRUCT(tp);
 				result = att_tup->attisdropped;
 				ReleaseSysCache(tp);
@@ -3262,10 +3262,10 @@ get_rte_attribute_is_dropped(RangeTblEntry *rte, AttrNumber attnum)
 		case RTE_NAMEDTUPLESTORE:
 			{
 				/* Check dropped-ness by testing for valid coltype */
-				if (attnum <= 0 ||
-					attnum > list_length(rte->coltypes))
-					elog(ERROR, "invalid varattno %d", attnum);
-				result = !OidIsValid((list_nth_oid(rte->coltypes, attnum - 1)));
+				if (attphysnum <= 0 ||
+					attphysnum > list_length(rte->coltypes))
+					elog(ERROR, "invalid varattno %d", attphysnum);
+				result = !OidIsValid((list_nth_oid(rte->coltypes, attphysnum - 1)));
 			}
 			break;
 		case RTE_JOIN:
@@ -3279,10 +3279,10 @@ get_rte_attribute_is_dropped(RangeTblEntry *rte, AttrNumber attnum)
 				 */
 				Var		   *aliasvar;
 
-				if (attnum <= 0 ||
-					attnum > list_length(rte->joinaliasvars))
-					elog(ERROR, "invalid varattno %d", attnum);
-				aliasvar = (Var *) list_nth(rte->joinaliasvars, attnum - 1);
+				if (attphysnum <= 0 ||
+					attphysnum > list_length(rte->joinaliasvars))
+					elog(ERROR, "invalid varattno %d", attphysnum);
+				aliasvar = (Var *) list_nth(rte->joinaliasvars, attphysnum - 1);
 
 				result = (aliasvar == NULL);
 			}
@@ -3304,8 +3304,8 @@ get_rte_attribute_is_dropped(RangeTblEntry *rte, AttrNumber attnum)
 				{
 					RangeTblFunction *rtfunc = (RangeTblFunction *) lfirst(lc);
 
-					if (attnum > atts_done &&
-						attnum <= atts_done + rtfunc->funccolcount)
+					if (attphysnum > atts_done &&
+						attphysnum <= atts_done + rtfunc->funccolcount)
 					{
 						TupleDesc	tupdesc;
 
@@ -3317,9 +3317,9 @@ get_rte_attribute_is_dropped(RangeTblEntry *rte, AttrNumber attnum)
 							Form_pg_attribute att_tup;
 
 							Assert(tupdesc);
-							Assert(attnum - atts_done <= tupdesc->natts);
+							Assert(attphysnum - atts_done <= tupdesc->natts);
 							att_tup = TupleDescAttr(tupdesc,
-													attnum - atts_done - 1);
+													attphysnum - atts_done - 1);
 							return att_tup->attisdropped;
 						}
 						/* Otherwise, it can't have any dropped columns */
@@ -3329,14 +3329,14 @@ get_rte_attribute_is_dropped(RangeTblEntry *rte, AttrNumber attnum)
 				}
 
 				/* If we get here, must be looking for the ordinality column */
-				if (rte->funcordinality && attnum == atts_done + 1)
+				if (rte->funcordinality && attphysnum == atts_done + 1)
 					return false;
 
 				/* this probably can't happen ... */
 				ereport(ERROR,
 						(errcode(ERRCODE_UNDEFINED_COLUMN),
 						 errmsg("column %d of relation \"%s\" does not exist",
-								attnum,
+								attphysnum,
 								rte->eref->aliasname)));
 				result = false; /* keep compiler quiet */
 			}
@@ -3346,7 +3346,7 @@ get_rte_attribute_is_dropped(RangeTblEntry *rte, AttrNumber attnum)
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_COLUMN),
 					 errmsg("column %d of relation \"%s\" does not exist",
-							attnum,
+							attphysnum,
 							rte->eref->aliasname)));
 			result = false;		/* keep compiler quiet */
 			break;
@@ -3402,12 +3402,12 @@ get_parse_rowmark(Query *qry, Index rtindex)
 }
 
 /*
- *	given relation and att name, return attnum of variable
+ *	given relation and att name, return attphysnum of variable
  *
  *	Returns InvalidAttrNumber if the attr doesn't exist (or is dropped).
  *
  *	This should only be used if the relation is already
- *	table_open()'ed.  Use the cache version get_attnum()
+ *	table_open()'ed.  Use the cache version get_attphysnum()
  *	for access to non-opened relations.
  */
 int
@@ -3448,7 +3448,7 @@ specialAttNum(const char *attname)
 
 	sysatt = SystemAttributeByName(attname);
 	if (sysatt != NULL)
-		return sysatt->attnum;
+		return sysatt->attphysnum;
 	return InvalidAttrNumber;
 }
 
